<script setup lang="ts">
import type * as Monaco from 'monaco-editor'
import type { PropType } from 'vue'
import { useErrorStore } from 'store/errorStore'
import { errorRangeKey } from 'store/events'
import type { DataTableColumns } from 'naive-ui'
import { NButton, useMessage } from 'naive-ui'

interface ErrorColumns {
  message: string
  location: string
  severity: number
}
type drawerTypes = 'error' | 'warning'

const props = defineProps({
  modelValue: {
    type: Boolean,
    default: false,
  },
  drawerType: {
    type: String as PropType<drawerTypes>,
    required: true,
  },
})
const emit = defineEmits(['update:modelValue'])
const errorStore = useErrorStore()
const message = useMessage()
const errorRange = useEventBus(errorRangeKey)

// State
const showDrawer = computed({
  get() {
    return props.modelValue
  },
  set(value) {
    emit('update:modelValue', value)
  },
})
const label = computed(() => {
  return props.drawerType === 'error' ? 'Errors' : 'Warnings'
})
const markers = computed(() => {
  return props.drawerType === 'error' ? errorStore.getErrors : errorStore.getWarnings.concat(errorStore.getInfo)
})
const data = computed(() => {
  return markers.value.map(marker => ({ message: marker?.message, location: `Ln ${marker?.startLineNumber === marker?.endLineNumber ? marker?.startLineNumber : `${marker?.startLineNumber} to ${marker?.endLineNumber}`}, Col ${marker?.startColumn === marker?.endColumn ? marker?.startColumn : `${marker?.startColumn} to ${marker?.endColumn}`}`, severity: marker?.severity }))
})

// Methods
const goToLine = (range: Monaco.IRange) => {
  errorRange.emit(range)
}
const createColumns = ({ errorMarkers }: {
  errorMarkers: (row: ErrorColumns, index: number) => void
}): DataTableColumns<ErrorColumns> => {
  return [
    {
      title: 'Message',
      key: 'message',
      className: 'text-xs',
      ellipsis: {
        tooltip: true,
      },
    },
    {
      title: 'Location',
      key: 'location',
      className: 'text-xs',
      ellipsis: {
        tooltip: true,
      },
    },
    {
      title: '',
      key: 'goto',
      align: 'right',
      width: 50,
      render(row, index) {
        return h(
          NButton,
          {
            text: true,
            size: 'tiny',
            title: 'Go To',
            class: 'flex flex-col items-center justify-center',
            innerHTML: '<i role="img" class="i-codicon:go-to-file block h-4 w-4" />',
            onClick: () => {
              showDrawer.value = false
              errorMarkers(row, index)
            },
          },
        )
      },
    },
  ]
}
const rowClassName = (row: ErrorColumns) => {
  if (row.severity === 1)
    return 'row-hint'
  if (row.severity === 2)
    return 'row-info'
  if (row.severity === 4)
    return 'row-warning'
  if (row.severity === 8)
    return 'row-error'

  return ''
}

// Instantiate Data Table
const columns = createColumns({
  errorMarkers(row: ErrorColumns, index: number) {
    const selectedMarker = markers.value[index]
    if (selectedMarker) {
      const selectedRange: Monaco.IRange = {
        startColumn: selectedMarker.startColumn,
        startLineNumber: selectedMarker.startLineNumber,
        endColumn: selectedMarker.endColumn,
        endLineNumber: selectedMarker.endLineNumber,
      }
      goToLine(selectedRange)
    }
    message.info(`Go to ${row.location}`)
  },
})
</script>

<template>
  <n-drawer :show="showDrawer" :width="400" placement="right" style="--n-color: rgba(249, 250, 251, 1)" @mask-click="showDrawer = false">
    <n-drawer-content style="--n-body-padding: 0">
      <n-divider title-placement="center" class="text-lg" :class="{ 'text-error': drawerType === 'error', 'text-warning': drawerType === 'warning' }">
        {{ label }}
      </n-divider>
      <n-data-table
        :bordered="false"
        :columns="columns"
        :data="data"
        :row-class-name="rowClassName"
        style="--n-merged-th-color: #00263A; --n-th-text-color: #e6e9eb;"
      >
        <template #empty>
          <div class="flex flex-col items-center justify-center space-y-lg">
            <i role="img" class="i-fa6-solid:thumbs-up block w-12 h-12 text-pacific" />
            <span>There are no {{ label.toLowerCase() }} in the current document.</span>
          </div>
        </template>
      </n-data-table>
      <template #footer>
        <more-info header="Having error trouble?">
          Check out the TE Knowledge Base on building Email Templates
        </more-info>
      </template>
    </n-drawer-content>
  </n-drawer>
</template>
